angular.module('focaModalProvincia')
    .controller('focaModalProvinciaController', [
        '$timeout',
        '$filter',
        '$scope',
        '$uibModalInstance',
        'focaModalProvinciaService',
        'filters',
        function($timeout, $filter, $scope, $uibModalInstance, focaModalProvinciaService, filters) {

            $scope.filters = filters;
            $scope.provincias = [];
            $scope.primerBusqueda = false;
            $scope.searchLoading = false;
            // pagination
            $scope.numPerPage = 10;
            $scope.currentPage = 1;
            $scope.filteredProvincias = [];
            $scope.currentPageProvincias = [];
            $scope.selectedProvincia = -1;

            $scope.busquedaPress = function(key) {
                if (key === 13) {
                    $scope.searchLoading = true;
                    focaModalProvinciaService.getProvincias().then(
                        function(res) {
                            $scope.searchLoading = false;
                            $scope.primerBusqueda = true;
                            $scope.provincias = res.data;
                            $scope.search(true);
                            primera();
                        }
                    );
                }
            };

            $scope.search = function(pressed) {
                if($scope.provincias.length > 0) {
                    $scope.filteredProvincias = $filter('filter')(
                        $scope.provincias, { $: $scope.filters }
                    );

                    if(pressed && $scope.filteredProvincias.length === 0) {
                        $timeout(function() {
                            angular.element('#search')[0].focus();
                            $scope.filters = '';
                        });
                    }

                    $scope.lastPage = Math.ceil(
                        $scope.filteredProvincias.length / $scope.numPerPage
                    );
                    $scope.resetPage();
                }
            };

            $scope.resetPage = function() {
                $scope.currentPage = 1;
                $scope.selectPage(1);
            };

            $scope.selectPage = function(page) {
                var start = (page - 1) * $scope.numPerPage;
                var end = start + $scope.numPerPage;
                $scope.paginas = [];
                $scope.paginas = calcularPages(page);
                $scope.currentPageProvincias = $scope.filteredProvincias.slice(start, end);
                $scope.currentPage = page;
            };

            $scope.select = function(vendedor) {
                $uibModalInstance.close(vendedor);
            };

            $scope.cancel = function() {
                $uibModalInstance.dismiss('cancel');
            };

            $scope.busquedaDown = function(key) {
                if (key === 40) {
                    primera(key);
                }
            };

            $scope.itemProvincia = function(key) {
                if (key === 38) {
                    anterior(key);
                }

                if (key === 40) {
                    siguiente(key);
                }

                if (key === 37) {
                    retrocederPagina();
                }

                if (key === 39) {
                    avanzarPagina();
                }
            };

            function calcularPages(paginaActual) {
                var paginas = [];
                paginas.push(paginaActual);

                if (paginaActual - 1 > 1) {

                    paginas.unshift(paginaActual - 1);
                    if (paginaActual - 2 > 1) {
                        paginas.unshift(paginaActual - 2);
                    }
                }

                if (paginaActual + 1 < $scope.lastPage) {
                    paginas.push(paginaActual + 1);
                    if (paginaActual + 2 < $scope.lastPage) {
                        paginas.push(paginaActual + 2);
                    }
                }

                if (paginaActual !== 1) {
                    paginas.unshift(1);
                }

                if (paginaActual !== $scope.lastPage) {
                    paginas.push($scope.lastPage);
                }

                return paginas;
            }

            function primera() {
                $scope.selectedProvincia = 0;
            }

            function anterior() {
                if ($scope.selectedProvincia === 0 && $scope.currentPage > 1) {
                    retrocederPagina();
                } else {
                    $scope.selectedProvincia--;
                }
            }

            function siguiente() {
                if ($scope.selectedProvincia < $scope.currentPageProvincias.length - 1) {
                    $scope.selectedProvincia++;
                } else {
                    avanzarPagina();
                }
            }

            function retrocederPagina() {
                if ($scope.currentPage > 1) {
                    $scope.selectPage($scope.currentPage - 1);
                    $scope.selectedProvincia = $scope.numPerPage - 1;
                }
            }

            function avanzarPagina() {
                if ($scope.currentPage < $scope.lastPage) {
                    $scope.selectPage($scope.currentPage + 1);
                    $scope.selectedProvincia = 0;
                }
            }

            $scope.busquedaPress(13);
        }]
    );
